Attribute VB_Name = "MTestSC"

Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function MessageBoxW Lib "user32" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long

Public Sub Main()
    Dim xlApp As Excel.Application
    Dim wkbNeedOpen As Excel.Workbook
    Set xlApp = New Excel.Application
    On Error Resume Next
    With xlApp
        .Visible = True
        .UserControl = True
        Set wkbNeedOpen = .Workbooks.Open(App.Path & "\QuanLyKho.xls")
        wkbNeedOpen.RunAutoMacros xlAutoOpen
    End With
    If Err.Number <> 0 Then
        MsgBoxUni VNI("Tap tin khong tm thay."), vbInformation + vbOKOnly, VNI("Thong bao")
    End If
    
    Set wkbNeedOpen = Nothing
    Set xlApp = Nothing

End Sub


Function MsgBoxUni(ByVal PromptUni As Variant, Optional ByVal Buttons As VbMsgBoxStyle = vbOKOnly, Optional ByVal TitleUni As Variant = vbNullString) As VbMsgBoxResult
'Function MsgBoxUni(ByVal PromptUni As Variant, Optional ByVal Buttons As VbMsgBoxStyle = vbOKOnly, Optional ByVal TitleUni As Variant, Optional HelpFile, Optional Context) As VbMsgBoxResult
'BStrMsg,BStrTitle : La chuoi Unicode
Dim BStrMsg, BStrTitle
    'Hm StrConv Chuyen chuoi ve ma Unicode
    BStrMsg = StrConv(PromptUni, vbUnicode)
    BStrTitle = StrConv(TitleUni, vbUnicode)

    MsgBoxUni = MessageBoxW(GetActiveWindow, BStrMsg, BStrTitle, Buttons)
End Function

'==================================================================
'Ham TCVN3toUNICODE, VNItoUNICODE duoc viet boi Binh - OverAC
'www.giaiphapexcel.com
Private Function TCVN3toUNICODE(vnstr As String)
Dim c As String, i As Integer
    For i = 1 To Len(vnstr)
        c = Mid(vnstr, i, 1)
        Select Case c
        Case "a": c = ChrW$(97)
        Case "": c = ChrW$(225)
        Case "": c = ChrW$(224)
        Case "": c = ChrW$(7843)
        Case "": c = ChrW$(227)
        Case "": c = ChrW$(7841)
        Case "": c = ChrW$(259)
        Case "": c = ChrW$(7855)
        Case "": c = ChrW$(7857)
        Case "": c = ChrW$(7859)
        Case "": c = ChrW$(7861)
        Case "": c = ChrW$(7863)
        Case "": c = ChrW$(226)
        Case "": c = ChrW$(7845)
        Case "": c = ChrW$(7847)
        Case "": c = ChrW$(7849)
        Case "": c = ChrW$(7851)
        Case "": c = ChrW$(7853)
        Case "e": c = ChrW$(101)
        Case "": c = ChrW$(233)
        Case "": c = ChrW$(232)
        Case "": c = ChrW$(7867)
        Case "": c = ChrW$(7869)
        Case "": c = ChrW$(7865)
        Case "": c = ChrW$(234)
        Case "": c = ChrW$(7871)
        Case "": c = ChrW$(7873)
        Case "": c = ChrW$(7875)
        Case "": c = ChrW$(7877)
        Case "": c = ChrW$(7879)
        Case "o": c = ChrW$(111)
        Case "": c = ChrW$(243)
        Case "": c = ChrW$(242)
        Case "": c = ChrW$(7887)
        Case "": c = ChrW$(245)
        Case "": c = ChrW$(7885)
        Case "": c = ChrW$(244)
        Case "": c = ChrW$(7889)
        Case "": c = ChrW$(7891)
        Case "": c = ChrW$(7893)
        Case "": c = ChrW$(7895)
        Case "": c = ChrW$(7897)
        Case "": c = ChrW$(417)
        Case "": c = ChrW$(7899)
        Case "": c = ChrW$(7901)
        Case "": c = ChrW$(7903)
        Case "": c = ChrW$(7905)
        Case "": c = ChrW$(7907)
        Case "i": c = ChrW$(105)
        Case "": c = ChrW$(237)
        Case "": c = ChrW$(236)
        Case "": c = ChrW$(7881)
        Case "": c = ChrW$(297)
        Case "": c = ChrW$(7883)
        Case "u": c = ChrW$(117)
        Case "": c = ChrW$(250)
        Case "": c = ChrW$(249)
        Case "": c = ChrW$(7911)
        Case "": c = ChrW$(361)
        Case "": c = ChrW$(7909)
        Case "": c = ChrW$(432)
        Case "": c = ChrW$(7913)
        Case "": c = ChrW$(7915)
        Case "": c = ChrW$(7917)
        Case "": c = ChrW$(7919)
        Case "": c = ChrW$(7921)
        Case "y": c = ChrW$(121)
        Case "": c = ChrW$(253)
        Case "": c = ChrW$(7923)
        Case "": c = ChrW$(7927)
        Case "": c = ChrW$(7929)
        Case "": c = ChrW$(7925)
        Case "": c = ChrW$(273)
        Case "A": c = ChrW$(65)
        Case "": c = ChrW$(258)
        Case "": c = ChrW$(194)
        Case "E": c = ChrW$(69)
        Case "": c = ChrW$(202)
        Case "O": c = ChrW$(79)
        Case "": c = ChrW$(212)
        Case "": c = ChrW$(416)
        Case "I": c = ChrW$(73)
        Case "U": c = ChrW$(85)
        Case "": c = ChrW$(431)
        Case "Y": c = ChrW$(89)
        Case "": c = ChrW$(272)
        End Select
        TCVN3toUNICODE = TCVN3toUNICODE + c
    Next i
End Function
Function VNItoUNICODE(vnstr As String)
Dim c As String, i As Integer
Dim db         As Boolean
    For i = 1 To Len(vnstr)
        db = False
        If i < Len(vnstr) Then
            c = Mid(vnstr, i + 1, 1)
            If c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or _
               c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or _
               c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or _
               c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or _
               c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or _
               c = "" Or c = "" Or c = "" Or c = "" Or c = "" Or c = "" Then db = True
        End If
        If db Then
            c = Mid(vnstr, i, 2)
            Select Case c
            Case "a": c = ChrW$(225)
            Case "a": c = ChrW$(224)
            Case "a": c = ChrW$(7843)
            Case "a": c = ChrW$(227)
            Case "a": c = ChrW$(7841)
            Case "a": c = ChrW$(259)
            Case "a": c = ChrW$(7855)
            Case "a": c = ChrW$(7857)
            Case "a": c = ChrW$(7859)
            Case "a": c = ChrW$(7861)
            Case "a": c = ChrW$(7863)
            Case "a": c = ChrW$(226)
            Case "a": c = ChrW$(7845)
            Case "a": c = ChrW$(7847)
            Case "a": c = ChrW$(7849)
            Case "a": c = ChrW$(7851)
            Case "a": c = ChrW$(7853)
            Case "e": c = ChrW$(233)
            Case "e": c = ChrW$(232)
            Case "e": c = ChrW$(7867)
            Case "e": c = ChrW$(7869)
            Case "e": c = ChrW$(7865)
            Case "e": c = ChrW$(234)
            Case "e": c = ChrW$(7871)
            Case "e": c = ChrW$(7873)
            Case "e": c = ChrW$(7875)
            Case "e": c = ChrW$(7877)
            Case "e": c = ChrW$(7879)
            Case "o": c = ChrW$(243)
            Case "o": c = ChrW$(242)
            Case "o": c = ChrW$(7887)
            Case "o": c = ChrW$(245)
            Case "o": c = ChrW$(7885)
            Case "o": c = ChrW$(244)
            Case "o": c = ChrW$(7889)
            Case "o": c = ChrW$(7891)
            Case "o": c = ChrW$(7893)
            Case "o": c = ChrW$(7895)
            Case "o": c = ChrW$(7897)
            Case "": c = ChrW$(7899)
            Case "": c = ChrW$(7901)
            Case "": c = ChrW$(7903)
            Case "": c = ChrW$(7905)
            Case "": c = ChrW$(7907)
            Case "u": c = ChrW$(250)
            Case "u": c = ChrW$(249)
            Case "u": c = ChrW$(7911)
            Case "u": c = ChrW$(361)
            Case "u": c = ChrW$(7909)
            Case "": c = ChrW$(7913)
            Case "": c = ChrW$(7915)
            Case "": c = ChrW$(7917)
            Case "": c = ChrW$(7919)
            Case "": c = ChrW$(7921)
            Case "y": c = ChrW$(253)
            Case "y": c = ChrW$(7923)
            Case "y": c = ChrW$(7927)
            Case "y": c = ChrW$(7929)
            Case "A": c = ChrW$(193)
            Case "A": c = ChrW$(192)
            Case "A": c = ChrW$(7842)
            Case "A": c = ChrW$(195)
            Case "A": c = ChrW$(7840)
            Case "A": c = ChrW$(258)
            Case "A": c = ChrW$(7854)
            Case "A": c = ChrW$(7856)
            Case "A": c = ChrW$(7858)
            Case "A": c = ChrW$(7860)
            Case "A": c = ChrW$(7862)
            Case "A": c = ChrW$(194)
            Case "A": c = ChrW$(7844)
            Case "A": c = ChrW$(7846)
            Case "A": c = ChrW$(7848)
            Case "A": c = ChrW$(7850)
            Case "A": c = ChrW$(7852)
            Case "E": c = ChrW$(201)
            Case "E": c = ChrW$(200)
            Case "E": c = ChrW$(7866)
            Case "E": c = ChrW$(7868)
            Case "E": c = ChrW$(7864)
            Case "E": c = ChrW$(202)
            Case "E": c = ChrW$(7870)
            Case "E": c = ChrW$(7872)
            Case "E": c = ChrW$(7874)
            Case "E": c = ChrW$(7876)
            Case "E": c = ChrW$(7878)
            Case "O": c = ChrW$(211)
            Case "O": c = ChrW$(210)
            Case "O": c = ChrW$(7886)
            Case "O": c = ChrW$(213)
            Case "O": c = ChrW$(7884)
            Case "O": c = ChrW$(212)
            Case "O": c = ChrW$(7888)
            Case "O": c = ChrW$(7890)
            Case "O": c = ChrW$(7892)
            Case "O": c = ChrW$(7894)
            Case "O": c = ChrW$(7896)
            Case "": c = ChrW$(7898)
            Case "": c = ChrW$(7900)
            Case "": c = ChrW$(7902)
            Case "": c = ChrW$(7904)
            Case "": c = ChrW$(7906)
            Case "U": c = ChrW$(218)
            Case "U": c = ChrW$(217)
            Case "U": c = ChrW$(7910)
            Case "U": c = ChrW$(360)
            Case "U": c = ChrW$(7908)
            Case "": c = ChrW$(7912)
            Case "": c = ChrW$(7914)
            Case "": c = ChrW$(7916)
            Case "": c = ChrW$(7918)
            Case "": c = ChrW$(7920)
            Case "Y": c = ChrW$(221)
            Case "Y": c = ChrW$(7922)
            Case "Y": c = ChrW$(7926)
            Case "Y": c = ChrW$(7928)
            End Select
        Else
            c = Mid(vnstr, i, 1)
            Select Case c
            Case "": c = ChrW$(417)
            Case "": c = ChrW$(237)
            Case "": c = ChrW$(236)
            Case "": c = ChrW$(7881)
            Case "": c = ChrW$(297)
            Case "": c = ChrW$(7883)
            Case "": c = ChrW$(432)
            Case "": c = ChrW$(7925)
            Case "": c = ChrW$(273)
            Case "": c = ChrW$(416)
            Case "": c = ChrW$(205)
            Case "": c = ChrW$(204)
            Case "": c = ChrW$(7880)
            Case "": c = ChrW$(296)
            Case "": c = ChrW$(7882)
            Case "": c = ChrW$(431)
            Case "": c = ChrW$(7924)
            Case "": c = ChrW$(272)
            End Select
        End If
        VNItoUNICODE = VNItoUNICODE + c
        If db Then i = i + 1
    Next i
End Function
Private Function UNICODEtoVNI(ByVal vnstr As String)
Dim c As String, i As Integer
   For i = 1 To Len(vnstr)
      c = Mid(vnstr, i, 1)
      Select Case c
         Case ChrW$(97): c = "a"
         Case ChrW$(225): c = "a"
         Case ChrW$(224): c = "a"
         Case ChrW$(7843): c = "a"
         Case ChrW$(227): c = "a"
         Case ChrW$(7841): c = "a"
         Case ChrW$(259): c = "a"
         Case ChrW$(7855): c = "a"
         Case ChrW$(7857): c = "a"
         Case ChrW$(7859): c = "a"
         Case ChrW$(7861): c = "a"
         Case ChrW$(7863): c = "a"
         Case ChrW$(226): c = "a"
         Case ChrW$(7845): c = "a"
         Case ChrW$(7847): c = "a"
         Case ChrW$(7849): c = "a"
         Case ChrW$(7851): c = "a"
         Case ChrW$(7853): c = "a"
         Case ChrW$(101): c = "e"
         Case ChrW$(233): c = "e"
         Case ChrW$(232): c = "e"
         Case ChrW$(7867): c = "e"
         Case ChrW$(7869): c = "e"
         Case ChrW$(7865): c = "e"
         Case ChrW$(234): c = "e"
         Case ChrW$(7871): c = "e"
         Case ChrW$(7873): c = "e"
         Case ChrW$(7875): c = "e"
         Case ChrW$(7877): c = "e"
         Case ChrW$(7879): c = "e"
         Case ChrW$(111): c = "o"
         Case ChrW$(243): c = "o"
         Case ChrW$(242): c = "o"
         Case ChrW$(7887): c = "o"
         Case ChrW$(245): c = "o"
         Case ChrW$(7885): c = "o"
         Case ChrW$(244): c = "o"
         Case ChrW$(7889): c = "o"
         Case ChrW$(7891): c = "o"
         Case ChrW$(7893): c = "o"
         Case ChrW$(7895): c = "o"
         Case ChrW$(7897): c = "o"
         Case ChrW$(417): c = ""
         Case ChrW$(7899): c = ""
         Case ChrW$(7901): c = ""
         Case ChrW$(7903): c = ""
         Case ChrW$(7905): c = ""
         Case ChrW$(7907): c = ""
         Case ChrW$(105): c = "i"
         Case ChrW$(237): c = ""
         Case ChrW$(236): c = ""
         Case ChrW$(7881): c = ""
         Case ChrW$(297): c = ""
         Case ChrW$(7883): c = ""
         Case ChrW$(117): c = "u"
         Case ChrW$(250): c = "u"
         Case ChrW$(249): c = "u"
         Case ChrW$(7911): c = "u"
         Case ChrW$(361): c = "u"
         Case ChrW$(7909): c = "u"
         Case ChrW$(432): c = ""
         Case ChrW$(7913): c = ""
         Case ChrW$(7915): c = "u"
         Case ChrW$(7917): c = ""
         Case ChrW$(7919): c = ""
         Case ChrW$(7921): c = ""
         Case ChrW$(121): c = "y"
         Case ChrW$(253): c = "y"
         Case ChrW$(7923): c = "y"
         Case ChrW$(7927): c = "y"
         Case ChrW$(7929): c = "y"
         Case ChrW$(7925): c = ""
         Case ChrW$(273): c = ""
         Case ChrW$(65): c = "A"
         Case ChrW$(193): c = "A"
         Case ChrW$(192): c = "A"
         Case ChrW$(7842): c = "A"
         Case ChrW$(195): c = "A"
         Case ChrW$(7840): c = "A"
         Case ChrW$(258): c = "A"
         Case ChrW$(7854): c = "A"
         Case ChrW$(7856): c = "A"
         Case ChrW$(7858): c = "A"
         Case ChrW$(7860): c = "A"
         Case ChrW$(7862): c = "A"
         Case ChrW$(194): c = "A"
         Case ChrW$(7844): c = "A"
         Case ChrW$(7846): c = "A"
         Case ChrW$(7848): c = "A"
         Case ChrW$(7850): c = "A"
         Case ChrW$(7852): c = "A"
         Case ChrW$(69): c = "E"
         Case ChrW$(201): c = "E"
         Case ChrW$(200): c = "E"
         Case ChrW$(7866): c = "E"
         Case ChrW$(7868): c = "E"
         Case ChrW$(7864): c = "E"
         Case ChrW$(202): c = "E"
         Case ChrW$(7870): c = "E"
         Case ChrW$(7872): c = "E"
         Case ChrW$(7874): c = "E"
         Case ChrW$(7876): c = "E"
         Case ChrW$(7878): c = "E"
         Case ChrW$(79): c = "O"
         Case ChrW$(211): c = "O"
         Case ChrW$(210): c = "O"
         Case ChrW$(7886): c = "O"
         Case ChrW$(213): c = "O"
         Case ChrW$(7884): c = "O"
         Case ChrW$(212): c = "O"
         Case ChrW$(7888): c = "O"
         Case ChrW$(7890): c = "O"
         Case ChrW$(7892): c = "O"
         Case ChrW$(7894): c = "O"
         Case ChrW$(7896): c = "O"
         Case ChrW$(416): c = ""
         Case ChrW$(7898): c = ""
         Case ChrW$(7900): c = ""
         Case ChrW$(7902): c = ""
         Case ChrW$(7904): c = ""
         Case ChrW$(7906): c = ""
         Case ChrW$(73): c = "I"
         Case ChrW$(205): c = ""
         Case ChrW$(204): c = ""
         Case ChrW$(7880): c = ""
         Case ChrW$(296): c = ""
         Case ChrW$(7882): c = ""
         Case ChrW$(85): c = "U"
         Case ChrW$(218): c = "U"
         Case ChrW$(217): c = "U"
         Case ChrW$(7910): c = "U"
         Case ChrW$(360): c = "U"
         Case ChrW$(7908): c = "U"
         Case ChrW$(431): c = ""
         Case ChrW$(7912): c = ""
         Case ChrW$(7914): c = ""
         Case ChrW$(7916): c = ""
         Case ChrW$(7918): c = ""
         Case ChrW$(7920): c = ""
         Case ChrW$(89): c = "Y"
         Case ChrW$(221): c = "Y"
         Case ChrW$(7922): c = "Y"
         Case ChrW$(7926): c = "Y"
         Case ChrW$(7928): c = "Y"
         Case ChrW$(7924): c = ""
         Case ChrW$(272): c = ""
      End Select
      UNICODEtoVNI = UNICODEtoVNI + c
   Next i
End Function

Function UNC(strTCVN3 As String)
    UNC = TCVN3toUNICODE(strTCVN3)
End Function
Function VNI(strVNI As String)
    VNI = VNItoUNICODE(strVNI)
End Function




